/* Редактирование Cinema 20-11-2021
Проект переведён на более распространенные датчики - термопары K-Type.
Ссылка на мелодию приветствия: https://clck.ru/Yw7Cz 

На текущий момент есть 3 проблемы:
1). Все три доступные версии программы для компьютера, до момента нажатия 
кнопки "start", не умеют отображать текущие температуры на графиках.
2). Автор не предоставил версию программы для компьютера, в которой 
работает автоматический режим верхнего излучателя.
Изменено подключение модулей MAX6675 для совместимости с новым шилдом.
3). Если физически отключили контроллер после работы станции с софтом, 
то, зачастую,  новое подключение контроллера к софту, даже после 
перезагрузки компьютера, приводит к невозможности работы станции, 
к бесконечному рестарту, или к зависанию контроллера. 

Авторское описание протокола общения контроллера и управляющей программы на компьютере:
"Программа передает показания температуры 4 байта, т.е. если температура указана выше 255°С, 
то программа раскладывает её на два байта, соответственно, максимальная температура будет 510°С, 
мне хватает. От станции в программу на компьютере, глядя по скетчу, передаются 6 байт:  
(AA) (AA это 170 в 10-тичном счислении - это постоянная, начало блока), 
первый байт температуры верхнего датчика, 
второй байт температуры верхнего датчика, 
первый байт температуры нижнего датчика, 
второй байт температуры нижнего датчика, 
и последний 255(FF), - это байт окончания блока.  
Обратно на контроллер приходят 4 байта: 
один байт заголовка (АА) - та самая постоянная 170, 
один байт на ШИМ верхнего нагревателя (тут диапазон 00-FF), 
один байт на ШИМ нижнего нагревателя (тут диапазон 00-FF) 
и один байт состояния подсветки дисплея, там по-моему два состояния 00 и 01 или 00 и FF точно уже не помню.
Хотел изначально протокол использовать Modbus RTU, но устройство Slave всего одно, Master тоже один, 
получается адресация ни к чему, контрольной суммы нет, поэтому нет проверки целостности пакета, 
не критично, скорости небольшие, линия связи короткая, поэтому протокол получился простейший." */
