//20-11-2021
//Ссылка на мелодию приветствия: https://clck.ru/Yw7Cz

#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3f, 16, 2);                                          //у моего дисплея адрес 0x3f
#include "Setting.h"
#include "Variables.h"
#ifdef max6675_lib                                                           //если используем внешнюю библиотеку MAX6675
#include <max6675.h>
MAX6675 thermocouple1(thermoCLK, thermoCS, thermoDO);
MAX6675 thermocouple2(thermoCLK, thermoCS2, thermoDO);
#endif

void setup() {
  Serial.begin(9600);
  Hello_guis();                                                              //приветствие
  delay(2000);
  Developer();          
  delay(2000);
  Developer2();
  SongHello();                                                               //мелодия приветствия 1
  //SongHello2();                                                              //мелодия приветствия 2 
  delay(2000);
  lcd.clear();
  
  //задаём состояние пинов подключения
  pinMode(RelayPin1, OUTPUT);
  pinMode(RelayPin2, OUTPUT);
  pinMode(EnableTop, OUTPUT);
  pinMode(EnableBottom, OUTPUT);
  //задаём состояние пинов, к которым подключены MAX6675
  pinMode(thermoCS, OUTPUT);
  pinMode(thermoCS2, OUTPUT);
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoDO, INPUT);

  digitalWrite(EnableTop, LOW);
  digitalWrite(EnableBottom, LOW);
  analogWrite(RelayPin1, LevelTop);
  analogWrite(RelayPin2, LevelBottom);

  nextRead = millis();
}

String addZeroes(const String& src, byte pad) {
  if (src.length() >= pad)
    return src;
  String result;
  byte add = pad - src.length();
  while (add--)
    result += "0";
  result += src;
  return result;
}

void loop() {

  if (millis() > nextRead) {
    nextRead = millis() + SENSOR_SAMPLING_TIME;
#ifdef max6675_lib
    Temp_Bottom = Temp_Bottom * 0.6 + 0.4 * (thermocouple1.readCelsius());                          //t°C нижнего излучателя
    Temp_Top = Temp_Top * 0.6 + 0.4 * (thermocouple2.readCelsius());                                //t°C датчика у чипа
#else
    Temp_Bottom = Temp_Bottom * 0.6 + 0.4 * (max6675_read_temp (thermoCLK, thermoCS2, thermoDO));   //t°C нижнего излучателя
    Temp_Top = Temp_Top * 0.6 + 0.4 * (max6675_read_temp (thermoCLK, thermoCS, thermoDO));          //t°C датчика у чипа
#endif
    ProtectTimer--;                                                                                 //таймер защиты запускаем
}

int i = 0;
int buffer[6];
if (Serial.available()) {
  delay(100);
  while (Serial.available() && i < 7) {
    buffer[i++] = Serial.read();
  }
  buffer[i++] = '\0';
}
if (i > 0) {
  if (buffer[0] == 0xAA) {
    LevelTop = buffer[1];
    LevelBottom = buffer[2];
    EnableLed = buffer[3];
    ProtectTimer = PROTECT_TIME;
  }
  Temp1 = int(Temp_Top);
  Temp11 = 0;
  if (Temp1 > 255) {
    Temp11 = Temp1 - 255;
    Temp1 = 255;
  }
  Temp2 = int(Temp_Bottom);
  Temp12 = 0;
  if (Temp2 > 255) {
    Temp12 = Temp2 - 255;
    Temp2 = 255;
  }
  Serial.write(170);
  Serial.write(Temp1);
  Serial.write(Temp11);
  Serial.write(Temp2);
  Serial.write(Temp12);
  Serial.write(255);
}
if (LevelTop == 0x00) {
  digitalWrite(EnableTop, LOW);
}
if (LevelTop != 0x00) {
  digitalWrite(EnableTop, HIGH);
}
if (LevelBottom == 0x00) {
  digitalWrite(EnableBottom, LOW);
}
if (LevelBottom != 0x00) {
  digitalWrite(EnableBottom, HIGH);
}
if (EnableLed == 0x00) {
  lcd.noBacklight();
}
if (EnableLed == 0xFF) {
  lcd.backlight();
}

analogWrite(RelayPin1, LevelTop);
analogWrite(RelayPin2, LevelBottom);

lcd.setCursor(1, 0);
lcd.print("TH:");
lcd.setCursor(1, 1);
lcd.print("BH:");
lcd.setCursor(8, 0);
lcd.print("PWR:");
lcd.setCursor(8, 1);
lcd.print("PWR:");
lcd.setCursor(4, 0);
lcd.print(addZeroes(String(int(Temp_Top)), DESIRED_WIDTH));
lcd.setCursor(4, 1);
lcd.print(addZeroes(String(int(Temp_Bottom)), DESIRED_WIDTH));
lcd.setCursor(12, 0);
lcd.print(addZeroes(String(int(LevelTop)), DESIRED_WIDTH));
lcd.setCursor(12, 1);
lcd.print(addZeroes(String(int(LevelBottom)), DESIRED_WIDTH));
}                                                                            //закрыли loop

void Hello_guis() {                                                          //приветствие
  lcd.begin();
  lcd.clear();
  lcd.backlight();
  lcd.setCursor(1, 0);
  lcd.print("REWORK STATION");
  lcd.setCursor(0, 1);
  lcd.print("v3.0.0  mvm_ksaa");
}
void Developer() {                                                           //авторы
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("radioservice.at.");
  lcd.setCursor(0, 1);
  lcd.print("ua/forum/27-34-1");
}

void Developer2() {                                                          //новые разработчики
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("geleos27 SOLOway");
  lcd.setCursor(0, 1);
  lcd.print("Amperka.ru/forum");
}

void SongHello() {                                                           //Мелодия приветствия
  tone(tonePin, 220, 102.272625);
  delay(113.63625);
  tone(tonePin, 261, 102.272625);
  delay(113.63625);
  tone(tonePin, 293, 204.54525);
  delay(227.2725);
  tone(tonePin, 293, 204.54525);
  delay(227.2725);
  tone(tonePin, 293, 102.272625);
  delay(113.63625);
  tone(tonePin, 329, 102.272625);
  delay(113.63625);
  tone(tonePin, 349, 204.54525);
  delay(227.2725);
  tone(tonePin, 349, 204.54525);
  delay(227.2725);
  tone(tonePin, 349, 102.272625);
  delay(113.63625);
  tone(tonePin, 391, 102.272625);
  delay(113.63625);
  tone(tonePin, 329, 204.54525);
  delay(227.2725);
  tone(tonePin, 329, 204.54525);
  delay(227.2725);
  tone(tonePin, 293, 102.272625);
  delay(113.63625);
  tone(tonePin, 261, 102.272625);
  delay(113.63625);
  tone(tonePin, 261, 102.272625);
  delay(113.63625);
  tone(tonePin, 293, 204.54525);
  delay(227.2725);
  delay(113.63625);
  tone(tonePin, 220, 102.272625);
  delay(113.63625);
  tone(tonePin, 261, 102.272625);
  delay(113.63625);
  tone(tonePin, 293, 204.54525);
  delay(227.2725);
  tone(tonePin, 293, 204.54525);
  delay(227.2725);
  tone(tonePin, 293, 102.272625);
  delay(113.63625);
  tone(tonePin, 329, 102.272625);
  delay(113.63625);
  tone(tonePin, 349, 204.54525);
  delay(227.2725);
  tone(tonePin, 349, 204.54525);
  delay(227.2725);
  tone(tonePin, 349, 102.272625);
  delay(113.63625);
  tone(tonePin, 391, 102.272625);
  delay(113.63625);
  tone(tonePin, 329, 204.54525);
  delay(227.2725);
  tone(tonePin, 329, 204.54525);
  delay(227.2725);
  tone(tonePin, 293, 102.272625);
  delay(113.63625);
  tone(tonePin, 261, 102.272625);
  delay(113.63625);
  tone(tonePin, 293, 306.817875);
  delay(340.90875);
  noTone(tonePin);
}

void SongHello2() {                                                          //Мелодия приветствия 2
  tone(tonePin, 523);
  delay(200);
  tone(tonePin, 659);
  delay(200);
  tone(tonePin, 784);
  delay(200);
  tone(tonePin, 1046);
  delay(200);
  noTone(tonePin);
}

#ifndef max6675_lib
double max6675_read_temp (int ck, int cs, int so) {                          //MAX6675 functions
  char i;
  int tmp = 0;
  digitalWrite(cs, LOW);//cs = 0;                                            //Stop a conversion in progress
  asm volatile (" nop"  "\n\t");
  for (i = 15; i >= 0; i--) {
    digitalWrite(ck, HIGH);
    asm volatile (" nop"  "\n\t");
    if ( digitalRead(so))
      tmp |= (1 << i);
    digitalWrite(ck, LOW);
    asm volatile (" nop"  "\n\t");
  }
  digitalWrite(cs, HIGH);
  if (tmp & 0x4) {
    return (255);
  } else
    return ((tmp >> 3)) * 0.25;
}
#endif
